﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Jemgine.MapEditor.Operations
{
	internal class NewSkeleton : Operation
	{
        Engine.Selection Selected;
        Engine.Selection ItemAdded;

        internal NewSkeleton(Engine.Selection Selected)
		{
			this.Selected = Selected;
		}

		internal override ReturnCode Do(EditorState ES)
		{
            Data.EntityRecord Entity = ES.GetTopObject(Selected) as Data.EntityRecord;
            if (Entity == null) return ReturnCode.DoNotAddToUndoStack;

			//if (!Selected.TopIsEntity()) return ReturnCode.DoNotAddToUndoStack;

            Entity.AttachedElements.Add(new Data.Skeleton());

            ItemAdded = new Engine.Selection(Engine.Selection.Types.EntityElement, Selected.TopIndex,
				Entity.AttachedElements.Count - 1, 0);
            ES.RebuildNode(ItemAdded.TopIndex);
			ES.SelectItem(ItemAdded);

			return ReturnCode.AddToUndoStack;
		}

		internal override void Undo(EditorState ES)
		{
			(ES.Map.Elements[ItemAdded.TopIndex] as Data.EntityRecord).AttachedElements.RemoveAt(ItemAdded.MiddleIndex);
            ES.RebuildNode(ItemAdded.TopIndex);
            ES.SelectItem(new Engine.Selection(Engine.Selection.Types.MapElement, ItemAdded.TopIndex, 0, 0));
		}
	}
}
