﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using System.Drawing;

namespace Jemgine.MapEditor
{
    [Tools.SelectableTool]
    public class AddBoneTool : Tool
    {
        public override Image GetIcon() { return System.Drawing.Image.FromFile("ToolIcons/addbone.bmp"); }

        public override void MouseDown(MouseInputState InputState, EditorState EditorState)
        {
            var TopObject = EditorState.GetTopObject(EditorState.Selected) as Data.EntityRecord;
            if (TopObject == null) return;

            var MiddleObject = EditorState.GetMiddleObject(EditorState.Selected);

            Vector2 LocalPosition = TopObject.TransformToLocalSpace(InputState.Position);
            bool Snap = (InputState.Modifiers & System.Windows.Forms.Keys.Alt) == System.Windows.Forms.Keys.Alt;
            if (Snap) LocalPosition = EditorState.SnapToGrid(LocalPosition);

            if (MiddleObject is Data.Skeleton && EditorState.Selected.Type == Engine.Selection.Types.Vertex)
                EditorState.PerformOperation(new Operations.InsertBone(EditorState.Selected, LocalPosition));
        }
    }
}
