﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using System.Windows.Forms;
using System.Drawing;


namespace Jemgine.MapEditor
{
    public class MouseInputState
    {
        public MouseButtons Button;
        public Vector2 Position;
        public Keys Modifiers;
        public Vector2 Delta;
    }

    public class Tool
    {
        public virtual void MouseDown(MouseInputState InputState, EditorState EditorState) { }
        public virtual void MouseMove(MouseInputState InputState, EditorState EditorState) { }
        public virtual void MouseUp(MouseInputState InputState, EditorState EditorState) { }
        public virtual Image GetIcon() { return System.Drawing.Image.FromFile("ToolIcons/default.bmp"); }
        public virtual void DrawExtra(Data.EditorDrawData Context, EditorState EditorState) { }
        public virtual void BeforeDraw(EditorState EditorState) { }
        public virtual void AfterDraw(EditorState EditorState) { }
    }
}
