float4x4 World;
float4x4 View;
float4x4 Projection;
float4 Color;

struct VertexShaderInput
{
	float4 Position : POSITION0;
};

struct VertexShaderOutput
{
    float4 Position : POSITION0;
};

VertexShaderOutput VertexShaderFunction(VertexShaderInput input)
{
    VertexShaderOutput output;
    
    float4 worldPosition = mul(input.Position, World);
    float4 viewPosition = mul(worldPosition, View);
    output.Position = mul(viewPosition, Projection);

    return output;
}

struct PixelShaderOutput
{
    float4 Color : COLOR0;
};

PixelShaderOutput PSColor(VertexShaderOutput input) : COLOR0
{
    PixelShaderOutput output;
    output.Color = Color; 
    output.Color.r *= output.Color.a;
    output.Color.g *= output.Color.a;
    output.Color.b *= output.Color.a;
    return output;
}

technique DrawColor
{
    pass Pass1
    {
		AlphaBlendEnable = true;
		BlendOp = Add;
		SrcBlend = One;
		DestBlend = InvSrcAlpha;
		ZEnable = true;
		ZWriteEnable = true;
		ZFunc = LessEqual;
		
        VertexShader = compile vs_2_0 VertexShaderFunction();
        PixelShader = compile ps_2_0 PSColor();
    }
}