﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Jemgine.Data.Dynamics
{
    [Jemgine.Engine.Category("Primitive"), Jemgine.Engine.Node]
    public class DistanceJoint : Dynamic
    {
        public float frequencyHz { get; set; }
        public float dampingRatio { get; set; }

        public DistanceJoint()
        {
            AddAnchor();
            AddAnchor();
        }

        public override Box2D.XNA.JointDef GetJointDef()
        {
            var A = GetEntityBody(Anchors[0].Target);
            var B = GetEntityBody(Anchors[1].Target);

            if (A == null || B == null) return null;

            var Def = new Box2D.XNA.DistanceJointDef();
            Def.Initialize(A, B, Anchors[0].Position, Anchors[1].Position);
            Def.frequencyHz = frequencyHz;
            Def.dampingRatio = dampingRatio;
            Def.collideConnected = ConnectedCollide;

            return Def;
        }
    }
}
