﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Jemgine.Data.Dynamics
{
    [Jemgine.Engine.Category("Primitive"), Jemgine.Engine.Node]
    public class RevoluteJoint : Dynamic
    {
        public bool enableLimit { get; set; }
        public float lowerAngle { get; set; }
        public float upperAngle { get; set; }
        public bool enableMotor { get; set; }
        public float motorSpeed { get; set; }
        public float maxMotorTorque { get; set; }

        public RevoluteJoint()
        {
            AddAnchor();
            AddAnchor();
        }

        public override Box2D.XNA.JointDef GetJointDef()
        {
            var A = GetEntityBody(Anchors[0].Target);
            var B = GetEntityBody(Anchors[1].Target);

            if (A == null || B == null) return null;

            var Def = new Box2D.XNA.RevoluteJointDef();
            Def.Initialize(A, B, Anchors[1].Position);
            Def.enableLimit = enableLimit;
            Def.lowerAngle = MathHelper.ToRadians(lowerAngle);
            Def.upperAngle = MathHelper.ToRadians(upperAngle);
            Def.enableMotor = enableMotor;
            Def.motorSpeed = motorSpeed;
            Def.maxMotorTorque = maxMotorTorque;

            Def.collideConnected = ConnectedCollide;

            return Def;
        }
    }
}
