using System;
using System.Windows.Forms;
using Microsoft.Xna.Framework.Graphics;


namespace Jemgine.EffectEditor
{
    /// <summary>
    /// The main entry point for the application.
    /// </summary>
    static class Program
    {

        [STAThread]
        static void Main()
        {

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

			EditorState EditorState = new EditorState();

            MainWindow MW = new MainWindow();
            EditorState.Services.AddService<IGraphicsDeviceService>(GraphicsDeviceService.AddRef(MW.Handle, 1, 1));

            if (EditorState.PrepareEpisodeContent())
            {
                MW.SetEditorState(EditorState);
                EditorState.NewMap();
                Application.Run(MW);

                EditorState.SaveConfig();
            }
        }
    }
}
